Index: EcnlProtoTool/trunk/asp3_dcre/utils/gentest.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/utils/gentest.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/utils/gentest.rb	(revision 429)
@@ -5,5 +5,5 @@
 #      Toyohashi Open Platform for Embedded Real-Time Systems
 # 
-#  Copyright (C) 2007-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2007-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -44,4 +44,8 @@
 #
 	
+Encoding.default_external = 'utf-8'
+require "pp"
+require "fileutils"
+
 #
 #  生成動作を決めるための設定
@@ -67,4 +71,5 @@
   "ref_mtx" => { 2 => "T_RMTX" },
   "ref_mbf" => { 2 => "T_RMBF" },
+  "ref_spn" => { 2 => "T_RSPN" },
   "get_mpf" => { 2 => "void *" },
   "pget_mpf" => { 2 => "void *" },
@@ -77,8 +82,10 @@
   "get_tid" => { 1 => "ID" },
   "get_did" => { 1 => "ID" },
+  "get_pid" => { 1 => "ID" },
   "get_lod" => { 2 => "uint_t" },
   "mget_lod" => { 3 => "uint_t" },
   "get_nth" => { 3 => "ID" },
   "mget_nth" => { 4 => "ID" },
+  "ref_mem" => { 2 => "T_RMEM" },
   "get_ipm" => { 1 => "PRI" },
   "get_som" => { 1 => "ID" }
@@ -86,5 +93,6 @@
 
 $functionParameters = {
-  "target_hrt_set_event" => "HRTCNT hrtcnt"
+  "target_hrt_set_event" => "HRTCNT hrtcnt",
+  "hook_hrt_set_event" => "HRTCNT hrtcnt"
 }
   
@@ -98,5 +106,6 @@
   
 $functionCheckParameter = {
-  "target_hrt_set_event" => "hrtcnt"
+  "target_hrt_set_event" => "hrtcnt",
+  "hook_hrt_set_event" => "hrtcnt"
 }
 
@@ -154,5 +163,5 @@
     lines.each do |line|
       @code[@currentCount].push(line)
-        end
+    end
   end
 
@@ -174,5 +183,5 @@
     # 処理カウント変数の生成
     if @countFlag
-      print("\nstatic uint_t\t#{@count_var} = 0;\n")
+      $outFile.print("\nstatic uint_t\t#{@count_var} = 0;\n")
     end
 
@@ -180,87 +189,87 @@
     case @puName
     when /^TASK([0-9]*)$/
-      print("\nvoid\n")
-      print("task#{$1}(intptr_t exinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("task#{$1}(intptr_t exinf)\n")
     when /^CYC([0-9]*)$/
-      print("\nvoid\n")
-      print("cyclic#{$1}_handler(intptr_t exinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("cyclic#{$1}_handler(intptr_t exinf)\n")
     when /^ALM([0-9]*)$/
-      print("\nvoid\n")
-      print("alarm#{$1}_handler(intptr_t exinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("alarm#{$1}_handler(intptr_t exinf)\n")
     when /^OVR$/
-      print("\nvoid\n")
-      print("overrun_handler(ID tskid, intptr_t exinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("overrun_handler(ID tskid, intptr_t exinf)\n")
     when /^ISR([0-9]*)$/
-      print("\nvoid\n")
-      print("isr#{$1}(intptr_t exinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("isr#{$1}(intptr_t exinf)\n")
     when /^INTHDR([0-9]*)$/
-      print("\nvoid\n")
-      print("inthdr#{$1}_handler(void)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("inthdr#{$1}_handler(void)\n")
     when /^CPUEXC([0-9]*)$/
-      print("\nvoid\n")
-      print("cpuexc#{$1}_handler(void *p_excinf)\n")
+      $outFile.print("\nvoid\n")
+      $outFile.print("cpuexc#{$1}_handler(void *p_excinf)\n")
     when /^EXTSVC([0-9]*)$/
-      print("\nER_UINT\n")
-      print("extsvc#{$1}_routine")
-      print("(intptr_t par1, intptr_t par2, intptr_t par3,\n")
-      print("\t\t\t\t\t\t\t\tintptr_t par4, intptr_t par5, ID cdmid)\n")
+      $outFile.print("\nER_UINT\n")
+      $outFile.print("extsvc#{$1}_routine")
+      $outFile.print("(intptr_t par1, intptr_t par2, intptr_t par3,\n")
+      $outFile.print("\t\t\t\t\t\t\t\tintptr_t par4, intptr_t par5, ID cdmid)\n")
     else
       if $functionValue[@puName]
-        print("\n#{$functionValue[@puName]}\n")
+        $outFile.print("\n#{$functionValue[@puName]}\n")
       else
-        print("\nvoid\n")
-      end
-      print(@puName)
+        $outFile.print("\nvoid\n")
+      end
+      $outFile.print(@puName)
       if $functionParameters[@puName]
-        print("(#{$functionParameters[@puName]})\n")
+        $outFile.print("(#{$functionParameters[@puName]})\n")
       else
-        print("(void)\n")
-      end
-    end
-
-    print("{\n")
+        $outFile.print("(void)\n")
+      end
+    end
+
+    $outFile.print("{\n")
 
     @variableList.each do |varName, varType|
       if /^(.+)\w*\*$/ =~ varType
         varBaseType = $1
-        print("\t#{varBaseType}")
-        print(varBaseType.length < 4 ? "\t\t*" : "\t*")
+        $outFile.print("\t#{varBaseType}")
+        $outFile.print(varBaseType.length < 4 ? "\t\t*" : "\t*")
       else
-        print("\t#{varType}")
-        print(varType.length < 4 ? "\t\t" : "\t")
-      end
-      print("#{varName};\n")
+        $outFile.print("\t#{varType}")
+        $outFile.print(varType.length < 4 ? "\t\t" : "\t")
+      end
+      $outFile.print("#{varName};\n")
     end
     if @silFlag
-      print("\tSIL_PRE_LOC;\n")
-    end
-    print("\n")
+      $outFile.print("\tSIL_PRE_LOC;\n")
+    end
+    $outFile.print("\n")
 
     if @countFlag
-      print("\tswitch (++#{@count_var}) {\n")
+      $outFile.print("\tswitch (++#{@count_var}) {\n")
       @code.keys.sort_by { |c| c.to_i }.each do |count|
-        print("\tcase #{count}:\n")
+        $outFile.print("\tcase #{count}:\n")
         @code[count].each do |line|
-          print("\t",line) if line != ""
-          print("\n")
+          $outFile.print("\t",line) if line != ""
+          $outFile.print("\n")
         end
-        print("\t\tcheck_point(0);\n\n")
-      end
-      print("\tdefault:\n")
-      print("\t\tcheck_point(0);\n")
-      print("\t}\n")
+        $outFile.print("\t\tcheck_assert(false);\n\n")
+      end
+      $outFile.print("\tdefault:\n")
+      $outFile.print("\t\tcheck_assert(false);\n")
+      $outFile.print("\t}\n")
     else
       @code[""].each do |line|
-        print(line,"\n")
-      end
-    end
-
-    print("\tcheck_point(0);\n")
+        $outFile.print(line,"\n")
+      end
+    end
+
+    $outFile.print("\tcheck_assert(false);\n")
     if /^EXTSVC([0-9]*)$/ =~ @puName
-      print("\treturn(E_SYS);\n")
+      $outFile.print("\treturn(E_SYS);\n")
     elsif $functionReturn[@pu_nama]
-      print("\treturn(#{$functionReturn[@puName]});\n")
-    end
-    print("}\n")
+      $outFile.print("\treturn(#{$functionReturn[@puName]});\n")
+    end
+    $outFile.print("}\n")
   end
 end
@@ -303,7 +312,7 @@
 def testStartCode(pu)
   # テスト開始コードは一度のみ出力する
-  if $startFlag == 0
+  if !$startFlag
     pu.append("\ttest_start(__FILE__);", "")
-    $startFlag = 1
+    $startFlag = true
   end
 end
@@ -312,5 +321,5 @@
 #  ターゲット依存部関数の振る舞いの読み込み
 #
-def targetFunction(line, checkNum)
+def targetFunction(line, checkNum, prcid)
   if /^([a-zA-Z_]+)\s*(.*)$/ =~ line
     functionName = $1
@@ -333,5 +342,5 @@
   end
 
-  pu.append("\tcheck_point(#{checkNum});");
+  pu.append("\tcheck_point#{$cpSuffix[prcid]}(#{checkNum});");
   if param && $functionCheckParameter[functionName]
     pu.append(sprintf("\tcheck_assert(%s == %s);",
@@ -347,10 +356,24 @@
 
 #
+#  チェックポイント番号の処理
+#
+def procCheckPoint(prcid, originalCheckNum, oline_list)
+  checkNum = ($lastCheckPoint[prcid] += 1).to_s
+  oline_list.each do |oline|
+    oline.sub!(/#{originalCheckNum}/, "#{checkNum}:")
+  end
+  return(checkNum)
+end
+
+#
 #  テストスクリプトの読み込み
 #
-def parseLine(line)
-  if /^==\s*(([a-zA-Z_]+)[0-9]*)(.*)$/ =~ line
+def parseLine(line, prcid, oline_list)
+  if /^==\s*START(_[a-zA-Z0-9]+)?(.*)$/ =~ line
+    $procFlag = true unless $procFlagEnd
+    $cpSuffix[prcid] = $1
+  elsif /^==\s*(([a-zA-Z_]+)[0-9]*)(.*)$/ =~ line
     # 処理単位の開始
-    $procFlag = 1
+    $procFlag = true unless $procFlagEnd
     puName = $1
     line2 = $3
@@ -359,5 +382,5 @@
       pu = $puList[puName] = PUCode.new(puName)
     end
-    $currentPu = pu
+    $currentPu[prcid] = pu
 
     case line2
@@ -369,18 +392,16 @@
       pu.setCount("")
     end
-    testStartCode(pu) if /^START/ !~ puName
-  elsif $procFlag != 0
-    pu = $currentPu
+    testStartCode(pu)
+  elsif $procFlag
+    pu = $currentPu[prcid]
     if /^([0-9]+\:)\s*(.*)$/ =~ line
       # チェックポイント番号の処理
-      originalCheckNum = $1
       line = $2
-      checkNum = ($lastCheckPoint += 1).to_s
-      $outputLine.sub!(/#{originalCheckNum}/, "#{checkNum}:")
+      checkNum = procCheckPoint(prcid, $1, oline_list)
 
       case line
       when /^END$/
-        pu.append("\tcheck_finish(#{checkNum});")
-        $procFlag = 0
+        pu.append("\tcheck_finish#{$cpSuffix[prcid]}(#{checkNum});")
+        $procFlagEnd = true
         return
       when /^HOOK\((.*)\)$/
@@ -388,8 +409,8 @@
         return
       when /^\[(.*)\]$/
-        targetFunction($1, checkNum)
+        targetFunction($1, checkNum, prcid)
         return
       else
-        pu.append("\tcheck_point(#{checkNum});")
+        pu.append("\tcheck_point#{$cpSuffix[prcid]}(#{checkNum});")
       end
     end
@@ -402,4 +423,6 @@
       pu.append("\t#{call_string};", "")
       pu.useSil() if /^SIL_..._INT\(\)$/ =~ call_string
+    when /^VAR\(\s*(.*)\s+(.*)\s*\)$/
+      pu.addVariable($2, $1)
     when /^RETURN((\(.*\))?)$/
       pu.append("\treturn#{$1};", "")
@@ -409,4 +432,8 @@
     when /^LABEL\((.*)\)$/
       pu.append("#{$1}:", "")
+    when /^BARRIER\((.*)\)$/
+      pu.append("\ttest_barrier(#{$1});", "")
+    when /^((SET|RESET|WAIT|WAIT_WO_RESET|WAIT_RESET)\(.*\))$/
+      pu.append("\t#{$1};", "")
     when /^([a-z_]+\(.*\))\s*(\-\>\s*([A-Za-z0-9_]*))?\s*$/
       genServiceCall(pu, $1, $3)
@@ -428,39 +455,65 @@
 #
 inFileName = ARGV.shift
+outFileName = inFileName + ".new"
 
 #
 #  スクリプトファイル読み込み処理
 #
-$lastCheckPoint = 0		# 最後のチェックポイント番号
-$procFlag = 0				# スクリプト処理中フラグ
-$startFlag = 0			# テスト開始コードの出力フラグ
-$currentPu = nil			# 読み込み中の処理単位
-$puList = {}				# 処理単位のリスト
+$procFlag = false					# スクリプト処理中フラグ
+$procFlagEnd = false				# スクリプト処理終了フラグ
+$startFlag = false					# テスト開始コードの出力フラグ
+$currentPu = {}						# 読み込み中の処理単位
+$puList = {}						# 処理単位のリスト
+$outputLines = []					# 出力すべき行のリストのリスト
+$cpSuffix = Hash.new("")			# チェックポイント関数のサフィックス
+$lastCheckPoint = Hash.new(0)		# 最後のチェックポイント番号
 
 begin
   inFile = File.open(inFileName)
+  $outFile = File.open(outFileName, "w")
 rescue Errno::ENOENT, Errno::EACCES => ex
   abort(ex.message)
 end
 
+statements = Hash.new("")
+oline_lists = Hash.new([])
 while line = inFile.gets do
-  $outputLine = line.dup
-  line.chomp!
-  line.sub!(/^\s*\*\s*/, "")
-  line.sub!(/\s*\/\/.*$/, "")
-  line.sub!(/\s*\.\.\..*$/, "")
-
-  while line.sub!(/\\$/, "") do
-    line1 = inFile.gets
-    $outputLine += line1.dup
-    line1.chomp!
-    line1.sub!(/^\s*\*\s*/, "")
-    line1.sub!(/\s*\/\/.*$/, "")
-    line1.sub!(/\s*\.\.\..*$/, "")
-    line += line1
-  end
-  parseLine(line) if line != ""
-  print($outputLine)
-  break if /DO NOT DELETE THIS LINE/ =~ $outputLine
+  line.chomp!									# 末尾の改行の削除
+  if /DO NOT DELETE THIS LINE/ =~ line
+    $outputLines.push([ line ])
+    break
+  elsif line =~ /^(\s*\*)(.*)$/					# 行頭のスペースと "*" の削除
+    outputLine = [ $1.dup ]
+    $2.split(/｜/, -1).each_with_index do |sline, index|
+      outLine = sline.dup
+      outputLine.push(outLine)
+      sline.sub!(/^\s*/, "")					# 先頭のスペースの削除
+      sline.sub!(/\/\/.*$/, "")					# // コメントの削除
+      sline.sub!(/\.\.\..*$/, "")				# ... コメントの削除
+
+      prcid = index + 1
+      statements[prcid] += sline
+      oline_lists[prcid].push(outLine)
+      next if statements[prcid].sub!(/\\\s*$/, "")		# 継続行の場合
+
+      statements[prcid].sub!(/\s*$/, "")		# 末尾のスペースの削除
+      if sline !~ /^\s*$/
+        parseLine(statements[prcid], prcid, oline_lists[prcid])
+      end
+      statements[prcid] = ""
+      oline_lists[prcid] = []
+    end
+    $outputLines.push(outputLine)
+    $procFlag = false if $procFlagEnd
+  else
+    $outputLines.push([ line ])
+  end
+end
+$outputLines.each do |outputLine|
+  outputLine.each_with_index do |sline, index|
+    $outFile.print("｜") if index > 1
+    $outFile.print(sline);
+  end
+  $outFile.print("\n");
 end
 
@@ -471,2 +524,8 @@
   $puList[puName].generateCode()
 end
+
+#
+#  ファイルの置き換え
+#
+FileUtils.move(inFileName, inFileName + ".bak")
+FileUtils.move(outFileName, inFileName)
Index: EcnlProtoTool/trunk/asp3_dcre/utils/makerelease.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/utils/makerelease.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/utils/makerelease.rb	(revision 429)
@@ -5,5 +5,5 @@
 #      Toyohashi Open Platform for Embedded Real-Time Systems
 # 
-#  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -40,5 +40,23 @@
 # 
 
+require "optparse"
+require "fileutils"
 require "shell"
+
+#
+#  オプションの定義
+#
+#  -e <dirname>			アーカイブファイルを展開して削除する．dirname
+#						は展開するディレクトリ名（省略可能）．
+
+#
+#  オプションの処理
+#
+OptionParser.new("Usage: makerelease.rb [options] MANIFEST-FILE") do |opt|
+  opt.on("-e [dirname]",	"expand archive file and delete") do |val|
+    $expandDirname = val
+  end
+  opt.parse!(ARGV)
+end
 
 #
@@ -108,6 +126,6 @@
     else
       fileName = $prefix + "/" + canonicalPath(baseDirectory + line)
-      if !File.file?("../" + fileName)
-        abort("#{fileName} is not a file.")
+      if !File.file?("../" + fileName) && !File.directory?("../" + fileName)
+        abort("#{fileName} is not a file or a directory.")
       elsif $fileList.index(fileName)
         abort("#{fileName} is duplicated.")
@@ -167,5 +185,24 @@
 archiveName = $package + "-" + $version + ".tar.gz"
 fileListStr = $fileList.join(" ")
-command = "tar cvfz RELEASE/#{archiveName} -C .. #{fileListStr}\n";
+command = "tar cvfz RELEASE/#{archiveName} -C .. #{fileListStr}";
 system(command)
-puts("== RELEASE/#{archiveName} is generated. ==\n")
+puts("== RELEASE/#{archiveName} is generated. ==")
+
+#
+#  アーカイブファイルの展開と削除
+#
+if defined?($expandDirname)
+  command = "tar xf RELEASE/#{archiveName}; rm RELEASE/#{archiveName}";
+  system(command)
+
+  dirname = $expandDirname || $prefix
+  if File.exist?(dirname)
+    File.rename(dirname, dirname + ".bak")
+    puts("== '#{dirname}' is renamed to '#{dirname}.bak'. ==")
+  end
+  if !$expandDirname.nil?
+    File.rename($prefix, $expandDirname)
+  end
+  puts("== RELEASE/#{archiveName} is expanded to '#{dirname}'. ==")
+  puts("== RELEASE/#{archiveName} is deleted. ==")
+end
Index: EcnlProtoTool/trunk/mbed_api/.cproject
===================================================================
--- EcnlProtoTool/trunk/mbed_api/.cproject	(revision 428)
+++ EcnlProtoTool/trunk/mbed_api/.cproject	(revision 429)
@@ -22,4 +22,5 @@
 				<option id="toolchain.id" value="gcc-arm-embedded"/>
 				<option id="toolchain.version" value="6.3.1.20170620"/>
+				<option id="toolchain.enable" value="false"/>
 			</storageModule>
 			<storageModule moduleId="cdtBuildSystem" version="4.0.0">
@@ -68,6 +69,7 @@
 									<listOptionValue builtIn="false" value="&quot;${ProjDirPath}/src&quot;"/>
 									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/musl-1.1.18/include}&quot;"/>
+									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/asp3_dcre/mbed}&quot;"/>
 									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/asp3_dcre/mbed/common}&quot;"/>
-									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/asp3_dcre/mbed/api}&quot;"/>
+									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/asp3_dcre/mbed/platform}&quot;"/>
 									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/asp3_dcre/mbed/hal}&quot;"/>
 									<listOptionValue builtIn="false" value="&quot;${workspace_loc:/${ProjName}/include}&quot;"/>
@@ -142,3 +144,4 @@
 		</configuration>
 	</storageModule>
+	<storageModule moduleId="org.eclipse.cdt.make.core.buildtargets"/>
 </cproject>
Index: EcnlProtoTool/trunk/mbed_api/src/mbed_api.c
===================================================================
--- EcnlProtoTool/trunk/mbed_api/src/mbed_api.c	(revision 428)
+++ EcnlProtoTool/trunk/mbed_api/src/mbed_api.c	(revision 429)
@@ -310,14 +310,38 @@
 }
 
-#include "assert.c"
-#include "board.c"
-#include "error.c"
-#include "gpio.c"
-#include "lp_ticker_api.c"
+void hal_critical_section_enter(void)
+{
+}
+
+void hal_critical_section_exit(void)
+{
+}
+
+void us_ticker_fire_interrupt(void)
+{
+}
+
+void us_ticker_free(void)
+{
+}
+
+//#include <pinmap.h>
+#define LED1 109
+#include "mbed_assert.c"
+#include "mbed_board.c"
+#include "mbed_critical.c"
+#include "mbed_error.c"
+#include "mbed_gpio.c"
+#include "mbed_lp_ticker_api.c"
 #include "mbed_interface.c"
-#include "pinmap_common.c"
-//#include "rtc_time.c"
-#include "semihost_api.c"
-#include "ticker_api.c"
-#include "us_ticker_api.c"
-#include "wait_api.c"
+#include "mbed_pinmap_common.c"
+//#include "mbed_rtc_time.c"
+#include "mbed_semihost_api.c"
+#include "mbed_ticker_api.c"
+#include "mbed_us_ticker_api.c"
+#include "mbed_wait_api_no_rtos.c"
+
+const ticker_info_t *us_ticker_get_info(void)
+{
+	return NULL;
+}
Index: EcnlProtoTool/trunk/ntshell/Debug/Makefile
===================================================================
--- EcnlProtoTool/trunk/ntshell/Debug/Makefile	(revision 428)
+++ EcnlProtoTool/trunk/ntshell/Debug/Makefile	(revision 429)
@@ -6,5 +6,5 @@
 #  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 #                              Toyohashi Univ. of Technology, JAPAN
-#  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -96,4 +96,10 @@
 
 #
+#  ã·ã¹ãã ãµã¼ãã¹ã³ã¼ã«ã©ã¤ãã©ãªï¼libsyssvc.aï¼ã®ãã£ã¬ã¯ããªå
+#  ï¼ã·ã¹ãã ãµã¼ãã¹ã³ã¼ã«ã©ã¤ãã©ãªãmakeå¯¾è±¡ã«ããæã¯ï¼ç©ºã«å®ç¾©ããï¼
+#
+SYSSVC_LIB = ../../asp3_dcre/Debug
+
+#
 #  ã«ã¼ãã«ãé¢æ°åä½ã§ã³ã³ãã¤ã«ãããã©ããã®å®ç¾©
 #
@@ -104,4 +110,9 @@
 #
 OMIT_TECS = 
+
+#
+#  TECSé¢ä¿ãã¡ã¤ã«ã®ãã£ã¬ã¯ããªã®å®ç¾©
+#
+TECSDIR = 
 
 #
@@ -134,7 +145,8 @@
 
 #
-#  ä¾å­é¢ä¿ãã¡ã¤ã«ãç½®ããã£ã¬ã¯ããªã®å®ç¾©
-#
-DEPDIR = deps
+#  ä¸­éãªãã¸ã§ã¯ããã¡ã¤ã«ã¨ä¾å­é¢ä¿ãã¡ã¤ã«ãç½®ããã£ã¬ã¯ããªã®å®ç¾©
+#
+OBJDIR = obj
+DEPDIR = obj
 
 #
@@ -165,4 +177,6 @@
 endif
 
+TINETDIR = tinet
+
 #
 #  mbedãµã¼ãã¹ã®å®ç¾©
@@ -175,5 +189,5 @@
 ±éã³ã³ãã¤ã«ãªãã·ã§ã³ã®å®ç¾©
 #
-COPTS := -g -std=gnu99 $(COPTS)
+COPTS := -g -std=gnu99 -ffunction-sections -fdata-sections $(COPTS)
 ifndef OMIT_WARNING_ALL
 	COPTS := -Wall $(COPTS)
@@ -207,5 +221,5 @@
 	APPL_COBJS := main.o fdtable.o io_stub.o socket_stub.o ffarch.o fftime.o tlsf.o diskio.o ff.o sdfs.o ccsbcs.o base64.o http-strings.o http_parser.o httpd.o httpd-fs.o sha1.o websocket.o websocket_fbs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o mbedcall.o
 endif
-APPL_COBJS := $(APPL_COBJS) log_output.o vasyslog.o t_perror.o strerror.o
+APPL_COBJS := $(APPL_COBJS) log_output.o vasyslog.o t_perror.o strerror.o mbed_stub.o
 APPL_BINOBJS := httpd_fs.o
 APPL_CFLAGS := $(APPL_CFLAGS)
@@ -214,5 +228,4 @@
 endif
 
-TINETDIR = tinet
 ifdef TINETDIR
 	#
@@ -250,11 +263,27 @@
 #  ã·ã¹ãã ãµã¼ãã¹ã«é¢ããå®ç¾©
 #
+ifdef TCINSTALL
+GCC_PATH = $(TCINSTALL)
+else
+GCC_PATH = $(shell which $(CC))/../../
+endif
+MALLOC_LIB = "${GCC_PATH}arm-none-eabi/lib/thumb/v7-ar/fpv3/hard/libc.a"
+MALLOC_OBJS = lib_a-reent.o lib_a-impure.o lib_a-malloc.o lib_a-mallocr.o lib_a-calloc.o lib_a-callocr.o lib_a-realloc.o lib_a-reallocr.o lib_a-sbrkr.o lib_a-freer.o
+
 SYSSVC_DIRS := $(TECSGENDIR) $(SRCDIR)/tecs_kernel \
 				$(SYSSVC_DIRS) $(SRCDIR)/syssvc
 SYSSVC_ASMOBJS := $(SYSSVC_ASMOBJS)
-SYSSVC_COBJS := $(INIT_TECS_COBJ) $(TECS_COBJS) $(SYSSVC_COBJS) \
-				 $(CXXRTS)
+SYSSVC_COBJS := $(SYSSVC_COBJS) $(TECS_COBJS) \
+				$(INIT_TECS_COBJ) $(CXXRTS)
 SYSSVC_CFLAGS := $(SYSSVC_CFLAGS)
-INCLUDES := $(INCLUDES) -I$(TECSGENDIR) -I$(SRCDIR)/tecs_kernel
+INCLUDES := $(INCLUDES) -I$(TECSGENDIR) -I$(SRCDIR)/tecs_kernel -I../../musl-1.1.18/include
+
+#
+#  ãã¬ã¼ã¹ã­ã°è¨é²ã®ãµã³ãã«ã³ã¼ãã«é¢ããå®ç¾©
+#
+ifdef ENABLE_TRACE
+	COPTS := $(COPTS) -DTOPPERS_ENABLE_TRACE
+	SYSSVC_DIRS := $(SYSSVC_DIRS) $(SRCDIR)/arch/tracelog
+endif
 
 #
@@ -263,5 +292,5 @@
 .PHONY: all
 ifndef OMIT_TECS
-all: tecs
+all: tecs | $(DEPDIR)
 #	@$(MAKE) check
 	@$(MAKE) check $(OBJNAME).bin
@@ -279,4 +308,5 @@
 #  ã³ã³ãã£ã®ã¥ã¬ã¼ã¿ã«é¢ããå®ç¾©
 #
+CFG_KERNEL := --kernel asp
 ifndef TINETDIR
   CFG_TRB := -T $(TARGETDIR)/target_kernel.trb
@@ -287,12 +317,12 @@
   CFG_TABS := --api-table $(TINET_ROOT)/tcpip_api.def:tcpip \
 			--api-table $(SRCDIR)/kernel/kernel_api.def:kernel \
-			--symval-table $(SRCDIR)/tinet/tcpip_sym.def \
+			--symval-table $(TINET_ROOT)/tcpip_sym.def \
 			--symval-table $(SRCDIR)/kernel/kernel_sym.def $(CFG_TABS)
 endif
 CFG_ASMOBJS := $(CFG_ASMOBJS)
 CFG_COBJS := kernel_cfg.o $(CFG_COBJS)
-CFG_OBJS := $(CFG_ASMOBJS) $(CFG_COBJS)
+CFG_CFLAGS := -DTOPPERS_CB_TYPE_ONLY $(CFG_CFLAGS)
+
 CFG2_OUT_SRCS := kernel_cfg.h kernel_cfg.c $(CFG2_OUT_SRCS)
-CFG_CFLAGS := -DTOPPERS_CB_TYPE_ONLY $(CFG_CFLAGS)
 
 #
@@ -325,7 +355,5 @@
 					$(foreach file,$(KERNEL_FCSRCS),$(file:.c=.o))
 endif
-ifdef OMIT_OFFSET_H
-	OFFSET_H =
-else
+ifdef TARGET_OFFSET_TRB
 	OFFSET_H = offset.h
 endif
@@ -343,5 +371,5 @@
 endif
 ifndef TARGET_TCPIP_TRB
-	TARGET_TCPIP_TRB := $(SRCDIR)/tinet/tinet.trb
+	TARGET_TCPIP_TRB := $(SRCDIR)/$(TINETDIR)/tinet.trb
 endif
 
@@ -356,9 +384,27 @@
 
 #
+#  ä¸­éãªãã¸ã§ã¯ããã¡ã¤ã«ãç½®ããã£ã¬ã¯ããªã®å¦ç
+#
+APPL_ASMOBJS   := $(addprefix $(OBJDIR)/, $(APPL_ASMOBJS))
+APPL_CXXOBJS   := $(addprefix $(OBJDIR)/, $(APPL_CXXOBJS))
+APPL_COBJS     := $(addprefix $(OBJDIR)/, $(APPL_COBJS))
+APPL_BINOBJS   := $(addprefix $(OBJDIR)/, $(APPL_BINOBJS))
+SYSSVC_ASMOBJS := $(addprefix $(OBJDIR)/, $(SYSSVC_ASMOBJS))
+SYSSVC_COBJS   := $(addprefix $(OBJDIR)/, $(SYSSVC_COBJS))
+KERNEL_ASMOBJS := $(addprefix $(OBJDIR)/, $(KERNEL_ASMOBJS))
+KERNEL_COBJS   := $(addprefix $(OBJDIR)/, $(KERNEL_COBJS))
+KERNEL_LCOBJS  := $(addprefix $(OBJDIR)/, $(KERNEL_LCOBJS))
+CFG_ASMOBJS    := $(addprefix $(OBJDIR)/, $(CFG_ASMOBJS))
+CFG_COBJS      := $(addprefix $(OBJDIR)/, $(CFG_COBJS))
+CFG_DMY        := $(addprefix $(OBJDIR)/, $(CFG_DMY))
+MALLOC_OBJS    := $(addprefix $(OBJDIR)/, $(MALLOC_OBJS))
+
+#
 #  ã³ã³ãã¤ã«ã®ããã®å¤æ°ã®å®ç¾©
 #
-KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS)
+APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS) $(APPL_BINOBJS)
 SYSSVC_OBJS = $(SYSSVC_ASMOBJS) $(SYSSVC_COBJS) $(HIDDEN_OBJS)
-APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS) $(APPL_BINOBJS)
+KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS) $(MALLOC_OBJS)
+CFG_OBJS = $(CFG_ASMOBJS) $(CFG_COBJS)
 ALL_OBJS = $(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
 											$(END_OBJS) $(HIDDEN_OBJS)
@@ -372,4 +418,12 @@
 	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L.
 endif
+ifdef SYSSVC_LIB
+	LIBS_DEP := $(LIBS_DEP) $(SYSSVC_LIB)/libsyssvc.a
+	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L$(SYSSVC_LIB)
+	REALCLEAN_FILES := $(REALCLEAN_FILES) libsyssvc.a
+else
+	LIBS_DEP := $(LIBS_DEP) libsyssvc.a
+	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L.
+endif
 
 ifdef TEXT_START_ADDRESS
@@ -394,5 +448,5 @@
 tecs $(TECSGEN_SRCS) $(TECS_HEADERS): $(TECSGEN_TIMESTAMP) ;
 $(TECSGEN_TIMESTAMP): $(APPL_CDL) $(TECS_IMPORTS)
-	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(TECS_CPP)" -g $(TECSGENDIR)
+	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(subst ", \", $(TECS_CPP))" -g $(TECSGENDIR)
 
 #
@@ -401,11 +455,10 @@
 cfg1_out.c cfg1_out.db: cfg1_out.timestamp ;
 cfg1_out.timestamp: $(APPL_CFG) $(TECSGEN_TIMESTAMP)
-	echo $(CFG_TABS)
-	$(CFG) --pass 1 --kernel asp $(INCLUDES) $(CFG_TABS) \
+	$(CFG) --pass 1 $(CFG_KERNEL) $(INCLUDES) $(CFG_TABS) \
 						-M $(DEPDIR)/cfg1_out_c.d $(TARGET_KERNEL_CFG) $<
 
-$(CFG1_OUT): $(START_OBJS) cfg1_out.o $(CFG_DMY) $(END_OBJS) $(HIDDEN_OBJS)
+$(CFG1_OUT): $(START_OBJS) $(OBJDIR)/cfg1_out.o $(CFG_DMY) $(END_OBJS) $(HIDDEN_OBJS)
 	$(LINK) $(CFLAGS) $(LDFLAGS) $(CFG1_OUT_LDFLAGS) -o $(CFG1_OUT) \
-						$(START_OBJS) cfg1_out.o $(CFG_DMY) $(END_OBJS)
+						$(START_OBJS) $(OBJDIR)/cfg1_out.o $(CFG_DMY) $(LIBS) $(END_OBJS) $(HIDDEN_OBJS)
 
 cfg1_out.syms: $(CFG1_OUT)
@@ -417,5 +470,5 @@
 $(CFG2_OUT_SRCS) cfg2_out.db: kernel_cfg.timestamp ;
 kernel_cfg.timestamp: cfg1_out.db cfg1_out.syms cfg1_out.srec
-	$(CFG) --pass 2 --kernel asp $(INCLUDES) $(CFG_TRB)
+	$(CFG) --pass 2 $(CFG_KERNEL) $(INCLUDES) $(CFG_TRB)
 
 #
@@ -424,5 +477,5 @@
 $(OFFSET_H): offset.timestamp ;
 offset.timestamp: cfg1_out.db cfg1_out.syms cfg1_out.srec
-	$(CFG) --pass 2 -O --kernel asp $(INCLUDES) -T $(TARGET_OFFSET_TRB) \
+	$(CFG) --pass 2 -O $(CFG_KERNEL) $(INCLUDES) -T $(TARGET_OFFSET_TRB) \
 				--rom-symbol cfg1_out.syms --rom-image cfg1_out.srec
 
@@ -436,7 +489,23 @@
 
 #
+#  ã·ã¹ãã ãµã¼ãã¹ã³ã¼ã«ã©ã¤ãã©ãªãã¡ã¤ã«ã®çæ
+#
+libsyssvc.a: $(filter-out $(OBJDIR)/tBannerMain.o, $(SYSSVC_OBJS))
+	rm -f libsyssvc.a
+	$(AR) -rcs libsyssvc.a $(filter-out $(OBJDIR)/tBannerMain.o, $(SYSSVC_OBJS))
+	$(RANLIB) libsyssvc.a
+
+#
+#  ä¸¦åmakeã®ããã®ä¾å­é¢ä¿ã®å®ç¾©
+#
+$(APPL_OBJS) $(filter-out $(CFG_DMY), $(SYSSVC_OBJS)): | kernel_cfg.timestamp
+$(APPL_ASMOBJS) $(filter-out $(CFG_DMY), $(SYSSVC_ASMOBJS)) $(KERNEL_ASMOBJS) $(CFG_ASMOBJS): \
+														| offset.timestamp
+
+#
 #  ç¹å¥ãªä¾å­é¢ä¿ã®å®ç¾©
 #
-tBannerMain.o: $(filter-out tBannerMain.o,$(ALL_OBJS)) $(LIBS_DEP)
+$(OBJDIR)/tBannerMain.o: $(filter-out $(OBJDIR)/tBannerMain.o,$(ALL_OBJS)) \
+																$(LIBS_DEP)
 
 #
@@ -448,5 +517,11 @@
 			-Wl,-Map=$(OBJNAME).map,--cref -Wl,--gc-sections -Wl,-e_kernel__start,--gc-keep-exported=_kernel_istk \
 			$(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
-			$(ALL_LIBS) $(END_OBJS)
+			-Wl,--start-group $(ALL_LIBS) -Wl,--end-group $(END_OBJS)
+
+#
+#  ä¾å­é¢ä¿ãã©ã«ãã®ä½æ
+#
+$(DEPDIR):
+	mkdir $@
 
 #
@@ -476,5 +551,5 @@
 check: check.timestamp ;
 check.timestamp: cfg2_out.db $(OBJNAME).syms $(OBJNAME).srec
-	$(CFG) --pass 3 --kernel asp -O $(INCLUDES) -T $(TARGET_CHECK_TRB) \
+	$(CFG) --pass 3 $(CFG_KERNEL) -O $(INCLUDES) -T $(TARGET_CHECK_TRB) \
 				--rom-symbol $(OBJNAME).syms --rom-image $(OBJNAME).srec
 	@echo "configuration check passed"
@@ -485,5 +560,5 @@
 .PHONY: clean
 clean:
-	rm -f \#* *~ *.o $(DEPDIR)/*.d $(CLEAN_FILES) check.timestamp
+	rm -f \#* *~ $(OBJDIR)/*.o $(DEPDIR)/*.d $(CLEAN_FILES) check.timestamp
 	rm -f $(OBJFILE) $(OBJNAME).syms $(OBJNAME).srec $(OBJNAME).bin
 	rm -f kernel_cfg.timestamp $(CFG2_OUT_SRCS) cfg2_out.db
@@ -495,9 +570,18 @@
 	rm -f libkernel.a
 endif
+ifndef SYSSVC_LIB
+	rm -f libsyssvc.a
+endif
+	rm -f $(MALLOC_OBJS)
 
 .PHONY: cleankernel
 cleankernel:
 	rm -f $(OFFSET_H) $(KERNEL_LIB_OBJS)
-	rm -f $(KERNEL_LIB_OBJS:%.o=$(DEPDIR)/%.d)
+	rm -f $(KERNEL_LIB_OBJS:$(OBJDIR)/%.o=$(DEPDIR)/%.d)
+
+.PHONY: cleansyssvc
+cleansyssvc:
+	rm -f $(SYSSVC_OBJS)
+	rm -f $(SYSSVC_OBJS:$(OBJDIR)/%.o=$(DEPDIR)/%.d)
 
 .PHONY: realclean
@@ -512,15 +596,15 @@
 #  ã®ã¿ãä»ãã¦ã³ã³ãã¤ã«ããï¼
 #
-ALL_CFG_COBJS = $(CFG_COBJS) cfg1_out.o
+ALL_CFG_COBJS = $(CFG_COBJS) $(OBJDIR)/cfg1_out.o
 ALL_CFG_ASMOBJS = $(CFG_ASMOBJS)
 
-$(ALL_CFG_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
-
-$(ALL_CFG_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(CFG_CFLAGS) $<
-
-$(ALL_CFG_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
+$(ALL_CFG_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
+
+$(ALL_CFG_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(CFG_CFLAGS) $<
+
+$(ALL_CFG_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
 
 #
@@ -574,67 +658,71 @@
 #  ã³ã³ãã¤ã«ã«ã¼ã«ã®å®ç¾©
 #
-$(KERNEL_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_LCOBJS): %.o:
-	$(CC) -DTOPPERS_$(*F) -o $@ -c -MD -MP -MF $(DEPDIR)/$*.d \
+$(KERNEL_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_LCOBJS): $(OBJDIR)/%.o:
+	$(CC) -c -o $@ -DTOPPERS_$(*F) -MD -MP -MF $(DEPDIR)/$*.d \
 									$(CFLAGS) $(KERNEL_CFLAGS) $<
 
-$(KERNEL_LCOBJS:.o=.s): %.s:
-	$(CC) -DTOPPERS_$(*F) -o $@ -S $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(SYSSVC_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(SYSSVC_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(SYSSVC_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(APPL_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_CXXOBJS): %.o: %.cpp
-	$(CXX) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_CXXOBJS:.o=.s): %.s: %.cpp
-	$(CXX) -S $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_BINOBJS): %.o: %.bin
-	$(OBJCOPY) -B arm -I binary -O elf32-littlearm --rename-section .data=.rodata $< $*.o
+$(KERNEL_LCOBJS:$(OBJDIR)/%.o=%.s): %.s:
+	$(CC) -S -o $@ -DTOPPERS_$(*F) $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(SYSSVC_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(SYSSVC_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(SYSSVC_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(APPL_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_CXXOBJS): $(OBJDIR)/%.o: %.cpp
+	$(CXX) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_CXXOBJS:$(OBJDIR)/%.o=%.s): %.s: %.cpp
+	$(CXX) -S -o $@ $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_BINOBJS): $(OBJDIR)/%.o: %.bin
+	$(OBJCOPY) -B arm -I binary -O elf32-littlearm --rename-section .data=.rodata $< $(OBJDIR)/$*.o
+
+$(MALLOC_OBJS): $(OBJDIR)/%.o:
+	$(AR) x $(MALLOC_LIB) $(notdir $@)
+	mv $(notdir $@) $@
 
 #
 #  ããã©ã«ãã³ã³ãã¤ã«ã«ã¼ã«ãä¸æ¸ã
 #
-%.o: %.c
+$(OBJDIR)/%.o: %.c
 	@echo "*** Default compile rules should not be used."
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
 
 %.s: %.c
 	@echo "*** Default compile rules should not be used."
-	$(CC) -S $(CFLAGS) $<
-
-%.o: %.cpp
+	$(CC) -S -o $@ $(CFLAGS) $<
+
+$(OBJDIR)/%.o: %.cpp
 	@echo "*** Default compile rules should not be used."
-	$(CXX) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CXX) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
 
 %.s: %.cpp
 	@echo "*** Default compile rules should not be used."
-	$(CXX) -S $(CFLAGS) $<
-
-%.o: %.S
+	$(CXX) -S -o $@ $(CFLAGS) $<
+
+$(OBJDIR)/%.o: %.S
 	@echo "*** Default compile rules should not be used."
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
